.code

;Convert ascii string to floating point
;Input:	pointer to ascii input buffer
;		pointer to floating point output acmltr
AscToFlp proc uses ebx esi edi,lpAsc:DWORD,lpAcmltr:DWORD

	mov		esi,lpAsc
	mov		edi,lpAcmltr
	invoke ClrAcmltr,edi
	mov		al,[esi]
	cmp		al,'-'
	jne		@f
	inc		esi
  @@:
	cmp		al,'+'
	jne		@f
	inc		esi
  @@:
	push	eax
	call	GetInt
	xor		ebx,ebx
	.if al=='.'
		inc		esi
		call	GetInt
	.endif
	.if al=='e' || al=='E'
		inc		esi
		call	GetExp
	.endif
	add		word ptr [edi+ACMLTRPRE-2],3FFEh+(ACMLTRPRE-2)*8
	invoke AdjustAcmltrLeft,edi
	.if SDWORD ptr ebx>0
		.while ebx>=9
			invoke DivAcmltrP10,edi,1000000000
			sub		ebx,9
		.endw
		.while ebx>=8
			invoke DivAcmltrP10,edi,100000000
			sub		ebx,8
		.endw
		.while ebx>=7
			invoke DivAcmltrP10,edi,10000000
			sub		ebx,7
		.endw
		.while ebx>=6
			invoke DivAcmltrP10,edi,1000000
			sub		ebx,6
		.endw
		.while ebx>=5
			invoke DivAcmltrP10,edi,100000
			sub		ebx,5
		.endw
		.while ebx>=4
			invoke DivAcmltrP10,edi,10000
			sub		ebx,4
		.endw
		.while ebx>=3
			invoke DivAcmltrP10,edi,1000
			sub		ebx,3
		.endw
		.while ebx>=2
			invoke DivAcmltrP10,edi,100
			sub		ebx,2
		.endw
		.while ebx
			invoke DivAcmltrP10,edi,10
			dec		ebx
		.endw
	.elseif SDWORD ptr ebx<0
	.endif
	pop		eax
	.if al=='-'
		or		byte ptr [edi+ACMLTRPRE-1],80h
	.endif
	ret

GetExp:
	retn

GetInt:
	mov		al,[esi]
	.if al>='0' && al<='9'
		invoke MulAcmltrP10,edi,10
		call	AddEax
		inc		ebx
		inc		esi
		jmp		GetInt
	.endif
	retn

AddEax:
	movzx	eax,byte ptr [esi]
	and		al,0Fh
	mov		cx,[edi+ACMLTRPRE-2]
	.if cx<4
		xor		edx,edx
		shr		eax,cl
		adc		eax,0
		mov		ecx,(ACMLTRPRE-2)/4
	  @@:
		adc		dword ptr [edi+edx*4],eax
		mov		eax,0
		inc		edx
		dec		ecx
		jne		@b
		jnb		@f
		invoke ShiftAcmltrRight,edi,1
	  @@:
	.endif
	retn
	
AscToFlp endp

;Convert floating point to ascii hex
;Input: pointer to ascii output buffer
;		pointer to floating point input acmltr
FlpToHex proc uses esi edi,lpHex:DWORD,lpAcmltr:DWORD

	mov		esi,lpAcmltr
	mov		edi,lpHex
	mov		ecx,ACMLTRPRE-1
  @@:
	mov		al,[esi+ecx]
	shr		al,4
	call	HexOut
	mov		al,[esi+ecx]
	and		al,0Fh
	call	HexOut
	dec		ecx
	jns		@b
	mov		byte ptr [edi],0
	ret

HexOut:
	.if al>9
		add		al,'A'-10
	.else
		add		al,'0'
	.endif
	stosb
	retn

FlpToHex endp

;Convert floating point to ascii
;Input: pointer to ascii output buffer
;		pointer to floating point input acmltr
;		flag for exponential form
FlpToAsc proc uses ebx esi edi,lpAsc:DWORD,lpAcmltr:DWORD,fExp:DWORD
	LOCAL	dCount:DWORD
	LOCAL	eCount:DWORD
	LOCAL	tCount:DWORD
	LOCAL	fFirst:DWORD

	mov		ebx,offset tmpacmltr1
	invoke CpyAcmltr,ebx,offset acmltrval1
;	invoke ClrAcmltr,ebx
;	mov		dword ptr [ebx+ACMLTRPRE-4],3FFF8000h	;1.0
	mov		esi,offset tmpacmltr0
	invoke CpyAcmltr,esi,lpAcmltr
	mov		dx,[esi+ACMLTRPRE-2]
	mov		edi,lpAsc
	;Test sign
	.if dx>7FFFh
		mov		byte ptr [edi],'-'
		inc		edi
		and		dx,7FFFh
		mov		[esi+ACMLTRPRE-2],dx
	.endif
	mov		tCount,DECIMALS
	.if fExp
		.if dx
			mov		eCount,0
			mov		edx,[esi+ACMLTRPRE-4]
			.while dword ptr [ebx+ACMLTRPRE-4]<edx
				inc		eCount
				invoke MulAcmltrP10,ebx,10
			.endw
			mov		edx,[ebx+ACMLTRPRE-4]
			.while dword ptr [esi+ACMLTRPRE-4]<edx
				dec		eCount
				invoke MulAcmltrP10,esi,10
			.endw
			mov		dCount,1
			.while word ptr [esi+ACMLTRPRE-2] && tCount
				dec		tCount
				mov		byte ptr [edi],2Fh
				invoke AdjustAcmltr,esi,ebx
			  @@:
				inc		byte ptr [edi]
				call	SubAcm
				jnb		@b
				call	AddAcm
				invoke MulAcmltrP10,esi,10
				.if dCount
					dec		dCount
					inc		edi
					mov		byte ptr [edi],'.'
				.endif
				inc		edi
			.endw
			mov		byte ptr [edi],'e'
			inc		edi
			invoke wsprintfA,edi,offset fmtStr,eCount
		.else
			mov		dword ptr [edi],'0e0'
		.endif
	.else
		.if dx
			mov		dCount,1
			mov		fFirst,0
			mov		edx,[esi+ACMLTRPRE-4]
			.while edx>dword ptr [ebx+ACMLTRPRE-4]
				inc		dCount
				invoke MulAcmltrP10,ebx,10
			.endw
			.while word ptr [esi+ACMLTRPRE-2] && tCount
				dec		tCount
				mov		byte ptr [edi],2Fh
				invoke AdjustAcmltr,esi,ebx
			  @@:
				inc		byte ptr [edi]
				call	SubAcm
				jnb		@b
				call	AddAcm
				invoke MulAcmltrP10,esi,10
				.if dCount
					dec		dCount
					.if !dCount
						inc		edi
						mov		byte ptr [edi],'.'
						mov		fFirst,edi
					.endif
				.endif
				inc		edi
				.if !fFirst
					.if byte ptr [edi-1]=='0'
						dec		edi
					.else
						inc		fFirst
					.endif
				.elseif fFirst>1000
					.if byte ptr [edi-1]!='0'
						mov		fFirst,edi
					.endif					
				.endif
			.endw
			.while dCount
				mov		byte ptr [edi],'0'
				inc		edi
				dec		dCount
			.endw
			.if fFirst>1000
				mov		edi,fFirst
			.endif
			mov		byte ptr [edi],0
		.else
			mov		word ptr [edi],'0'
		.endif
	.endif
	ret

SubAcm:
	mov		ecx,(ACMLTRPRE-2)/4
	xor		edx,edx
  @@:
	mov		eax,[ebx+edx*4]
	sbb		[esi+edx*4],eax
	inc		edx
	dec		ecx
	jne		@b
	retn

AddAcm:
	mov		ecx,(ACMLTRPRE-2)/4
	xor		edx,edx
  @@:
	mov		eax,[ebx+edx*4]
	adc		[esi+edx*4],eax
	inc		edx
	dec		ecx
	jne		@b
	retn

FlpToAsc endp

