.code

;Clear acmltr
ClrAcmltr proc uses ecx edi,lpAcmltr:DWORD

	mov		edi,lpAcmltr
	mov		ecx,ACMLTRPRE/2
	xor		ax,ax
	rep stosw
	ret

ClrAcmltr endp

;Copy from acmltr to acmltr
CpyAcmltr proc uses ecx esi edi,lpAcmltrDest:DWORD,lpAcmltrSrc:DWORD

	mov		esi,lpAcmltrSrc
	mov		edi,lpAcmltrDest
	mov		ecx,(ACMLTRPRE-2)/4
	rep movsd
	movsw
	ret

CpyAcmltr endp

;Shift acmltr pointed to by lpAcmltr right one bit
;and increment the exponent by one.
ShiftAcmltrRight proc uses ecx edi,lpAcmltr:DWORD,fShiftIn:DWORD

	mov		edi,lpAcmltr
	inc		word ptr [edi+ACMLTRPRE-2]
	mov		ecx,((ACMLTRPRE-2)/4)-1
	shr		fShiftIn,1
  @@:
	rcr		dword ptr [edi+ecx*4],1
	dec		ecx
	jns		@b
;	jnc		@f
;	invoke IncAcmltr,edi
;  @@:
	ret

ShiftAcmltrRight endp

;Shift acmltr pointed to by lpAcmltr left one bit
;and decrement the exponent by one. Test for zero
ShiftAcmltrLeft proc uses ecx edx edi,lpAcmltr:DWORD,fShiftIn:DWORD

	mov		edi,lpAcmltr
	dec		word ptr [edi+ACMLTRPRE-2]
	mov		ecx,(ACMLTRPRE-2)/4
	xor		edx,edx
	xor		eax,eax
	shl		fShiftIn,1
  Nxt:
	rcl		dword ptr [edi+edx*4],1
	je		@f
	mov		ax,[edi+ACMLTRPRE-2]
  @@:
	inc		edx
	dec		ecx
	jne		Nxt
	mov		[edi+ACMLTRPRE-2],ax
	ret

ShiftAcmltrLeft endp

;Left align tmpacmltr
AdjustAcmltrLeft proc uses edi,lpAcmltr:DWORD

	mov		edi,lpAcmltr
  @@:
	test	byte ptr [edi+ACMLTRPRE-3],80h
	jne		@f
	invoke ShiftAcmltrLeft,edi,0
	test	word ptr [edi+ACMLTRPRE-2],0FFFFh
	jne		@b
  @@:
	ret

AdjustAcmltrLeft endp

IncAcmltr proc uses ecx edx edi,lpAcmltr:DWORD

	mov		edi,lpAcmltr
	mov		ecx,(ACMLTRPRE-2)/4
	xor		edx,edx
	xor		eax,eax
	inc		eax
  Nxt:
	adc		[edi+edx*4],eax
	mov		eax,0
	inc		edx
	dec		ecx
	jne		Nxt
	jnc		@f
	invoke ShiftAcmltrRight,edi,1
  @@:
	ret

IncAcmltr endp

MulAcmltrP10 proc uses ebx ecx edx edi,lpAcmltr:DWORD,p10:DWORD

	mov		edi,lpAcmltr
	xor		ebx,ebx
	xor		ecx,ecx
  Nxt:
	mov		eax,[edi+ecx*4]
	mul		p10
	add		eax,ebx
	mov		[edi+ecx*4],eax
	adc		edx,0
	mov		ebx,edx
	inc		ecx
	cmp		ecx,(ACMLTRPRE-2)/4
	jne		Nxt
	or		ebx,ebx
	je		Ex
  @@:
	invoke ShiftAcmltrRight,edi,ebx
	shr		ebx,1
	jne		@b
  Ex:
	ret

MulAcmltrP10 endp

DivAcmltrP10 proc uses ebx ecx edx edi,lpAcmltr:DWORD,p10:DWORD

	mov		edi,lpAcmltr
	mov		ecx,((ACMLTRPRE-2)/4)-1
	mov		ebx,p10
	xor		edx,edx
  Nxt:
	mov		eax,[edi+ecx*4]
	div		ebx
	mov		[edi+ecx*4],eax
	dec		ecx
	jns		Nxt
	xor		eax,eax
	div		ebx
	mov		ecx,eax
	xor		eax,eax
	div		ebx
	mov		ebx,eax
	xor		eax,eax
	div		p10
	mov		edx,eax
  @@:
	test	word ptr [edi+ACMLTRPRE-2],0FFFFh
	je		Ex
	test	byte ptr [edi+ACMLTRPRE-3],80h
	jne		@f
	invoke ShiftAcmltrLeft,edi,ecx
	shl		edx,1
	rcl		ebx,1
	rcl		ecx,1
	jmp		@b
  @@:
	shl		ecx,1
	jnc		Ex
	invoke IncAcmltr,edi
  Ex:
	ret

DivAcmltrP10 endp

;prepare the acmltrs for add or sub
;In order to add or sub, the acmltrs must have the same exponent
;This is done by shifting the smallest tmpacmltr right.
AdjustAcmltr proc uses ecx esi edi,lpAcmltr0:DWORD,lpAcmltr1:DWORD

	mov		esi,lpAcmltr0
	mov		edi,lpAcmltr1
	mov		cx,[edi+ACMLTRPRE-2]
	sub		cx,[esi+ACMLTRPRE-2]
	je		Ex
	.if CARRY?
		neg		cx
		mov		esi,edi
	.endif
  @@:
	invoke ShiftAcmltrRight,esi,0
	dec		cx
	jne		@b
	jnc		Ex
	invoke IncAcmltr,esi
  Ex:
	ret

AdjustAcmltr endp

;Add acmltr0 and acmltr1, result in acmltr2
AddAcmltr proc uses ebx esi edi

	invoke AdjustAcmltr,esi,edi
	mov		ax,[esi+ACMLTRPRE-2]
	mov		[ebx+ACMLTRPRE-2],ax
	mov		ecx,(ACMLTRPRE-2)/4
	xor		edx,edx
  Nxt:
	mov		eax,[esi+edx*4]
	adc		eax,[edi+edx*4]
	mov		[ebx+edx*4],eax
	inc		edx
	dec		ecx
	jne		Nxt
	jnc		@f
	invoke ShiftAcmltrRight,ebx,1
  @@:
	ret

AddAcmltr endp

;Subtract acmltr1 from acmltre0, result in acmltr2
SubAcmltr proc uses ebx esi edi

	invoke AdjustAcmltr,esi,edi
	mov		ax,[esi+ACMLTRPRE-2]
	mov		[ebx+ACMLTRPRE-2],ax
	mov		ecx,(ACMLTRPRE-2)/4
	xor		edx,edx
  Nxt:
	mov		eax,[esi+edx*4]
	sbb		eax,[edi+edx*4]
	mov		[ebx+edx*4],eax
	inc		edx
	dec		ecx
	jne		Nxt
	jnb		@f
	xchg	esi,edi
	invoke SubAcmltr
	xor		byte ptr [ebx+ACMLTRPRE-1],80h
  @@:
	invoke AdjustAcmltrLeft,ebx
	ret

SubAcmltr endp

;Multiply acmltr0 by acmltr1, result in acmltr2
MulAcmltr proc uses ebx esi edi
	LOCAL	tmp[ACMLTRPRE*2-2]:BYTE

	push	edi
	lea		edi,tmp
	mov		ecx,sizeof tmp
	xor		eax,eax
	rep stosb
	pop		edi
	mov		ax,[esi+ACMLTRPRE-2]
	add		ax,[edi+ACMLTRPRE-2]
	sub		ax,3FFeh
	push	eax
	push	ebx
	lea		ebx,tmp
	mov		ecx,(ACMLTRPRE-2)/4
	xor		edx,edx
  Nxt:
	mov		eax,[esi+edx*4]
	call	Mult
	add		ebx,4
	inc		edx
	dec		ecx
	jne		Nxt
	DumpMem addr tmp,18
	lea		edi,[tmp]
	xor		esi,esi
	call Normalize
	lea		eax,[tmp+ACMLTRPRE-2]
	pop		ebx
	invoke CpyAcmltr,ebx,eax
	pop		eax
	add		eax,esi
	mov		[ebx+ACMLTRPRE-2],ax
	ret

Normalize:
	test	byte ptr [edi+((ACMLTRPRE-2)*2-1)],80h
	jne		@f
	xor		edx,edx
	mov		ecx,(ACMLTRPRE-2)*2/4
	dec		esi
  Norm1:
	rcl		dword ptr [edi+edx*4],1
	inc		edx
	dec		ecx
	jne		Norm1
	jmp		Normalize
  @@:
	retn

Mult:
	push	ecx
	push	edx
	xor		ecx,ecx
	xor		edx,edx
  Nx:
	push	eax
	mul		dword ptr [edi+ecx*4]
	add		[ebx+ecx*4],eax
	adc		[ebx+ecx*4+4],edx
	adc		dword ptr [ebx+ecx*4+8],0
	jc		Err
	pop		eax
	inc		ecx
	cmp		ecx,(ACMLTRPRE-2)/4
	jne		Nx
	pop		edx
	pop		ecx
	retn
Err:
	invoke MessageBox,0,addr szTest,addr szTest,MB_OK
	pop		edx
	pop		ecx
	retn

MulAcmltr endp

;Divide acmltr0 by acmltr1, result in acmltr2
;Simular to what you would do by hand, except you
;would estimate by multiplication before subtracting.
DivAcmltr proc uses ebx esi edi

	ret

DivAcmltr endp

DoMath proc uses ebx esi edi,hWin:HWND,nFun:DWORD
	LOCAL	buffer[256]:BYTE

	invoke GetDlgItemText,hWin,IDC_EDT1,addr buffer,sizeof buffer
	;Convert entered ascii to BCD
	invoke AscToFlp,addr buffer,offset acmltr0
	invoke GetDlgItemText,hWin,IDC_EDT5,addr buffer,sizeof buffer
	;Convert entered ascii to BCD
	invoke AscToFlp,addr buffer,offset acmltr1
	mov		esi,offset acmltr0
	mov		edi,offset acmltr1
	mov		ebx,offset acmltr2
	invoke ClrAcmltr,ebx
	mov		dl,[esi+ACMLTRPRE-1]
	mov		dh,[edi+ACMLTRPRE-1]
	mov		eax,nFun
	.if eax==IDC_BTN1					;Add
		.if dl<80h && dh<80h			;(+X)+(+Y)
			call	AddAcmltr
		.elseif dl<80h && dh>80h		;(+X)+(-Y)
			xor		byte ptr [edi+ACMLTRPRE-1],80h
			call	SubAcmltr
		.elseif dl>80h && dh<80h		;(-X)+(+Y)
			xchg	esi,edi
			xor		byte ptr [edi+ACMLTRPRE-1],80h
			call	SubAcmltr
		.elseif dl>80h && dh>80h		;(-X)+(-Y)
			call	AddAcmltr
		.endif
	.elseif eax==IDC_BTN2				;Sub
		.if dl<80h && dh<80h			;(+X)-(+Y)
			call	SubAcmltr
		.elseif dl<80h && dh>80h		;(+X)-(-Y)
			xor		byte ptr [edi+ACMLTRPRE-1],80h
			call	AddAcmltr
		.elseif dl>80h && dh<80h		;(-X)-(+Y)
			xor		byte ptr [esi+ACMLTRPRE-1],80h
			call	AddAcmltr
		.elseif dl>80h && dh>80h		;(-X)-(-Y)
			xchg	esi,edi
			xor		byte ptr [esi+ACMLTRPRE-1],80h
			xor		byte ptr [edi+ACMLTRPRE-1],80h
			call	SubAcmltr
		.endif
	.elseif eax==IDC_BTN3				;Mul
		.if word ptr [esi+ACMLTRPRE-2] && word ptr [edi+ACMLTRPRE-2]
			and		byte ptr [esi+ACMLTRPRE-1],7Fh
			and		byte ptr [edi+ACMLTRPRE-1],7Fh
			xor		dl,dh					;Get sign
			and		dl,80h
			push	edx
			call	MulAcmltr
;invoke CpyAcmltr,ebx,edi
			pop		edx
			or		[ebx+ACMLTRPRE-1],dl	;Set sign
		.endif
	.elseif eax==IDC_BTN4				;Div
;		.if dl && dh
;			and		byte ptr [esi+ACMLTRPRE-1],7Fh
;			and		byte ptr [edi+ACMLTRPRE-1],7Fh
;			and		dx,8080h				;Get sign
;			xor		dl,dh
;			push	edx
;			call	DivAcmltr
;			mov		al,[esi+ACMLTRPRE-1]
;			mov		ah,[edi+ACMLTRPRE-1]
;			sub		ah,41h+(ACMLTRPRE-1)*2
;			sub		al,ah
;			add		[ebx+ACMLTRPRE-1],al
;			pop		edx
;			or		[ebx+ACMLTRPRE-1],dl	;Set sign
;		.endif
	.endif
	ret

DoMath endp
