;This demo shows how to set and read a hotkey control
;and how to use that to create an accelerator table.

.386
.model flat,stdcall
option casemap:none

include HotKey.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateAccelerator,hWnd,hAccel,addr msg
		.if !eax
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
		.endif
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

SetHotkey proc nKey:DWORD
	LOCAL	accel:myACCEL

	.if hAccel
		;Destroy the old accelerator table
		invoke DestroyAcceleratorTable,hAccel
	.endif
	lea		edx,accel
	mov		eax,nKey
	;Just to match ah with FSHIFT, FCONTROL and FALT bit flags
	shl		ah,2
	or		ah,FVIRTKEY or FNOINVERT
	mov		[edx].myACCEL.fVirt,ah
	movzx	eax,al
	mov		[edx].myACCEL.key,ax
	mov		[edx].myACCEL.cmd,IDM_HELP_ABOUT
	;Create the new accelerator table
	invoke CreateAcceleratorTable,addr accel,1
	mov		hAccel,eax
	ret

SetHotkey endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		;Make F1 the initial hothey / accelerator
		invoke SetHotkey,VK_F1
		invoke SendDlgItemMessage,hWin,IDC_HOT1,HKM_SETHOTKEY,VK_F1,0
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDC_BTN1
			invoke SendDlgItemMessage,hWin,IDC_HOT1,HKM_GETHOTKEY,0,0
			invoke SetHotkey,eax
		.elseif eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
