; Code by X05
; email: X05_44960@hotmail.com
; rev: 1

include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include gdi32.inc
include comctl32.inc
include comdlg32.inc

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib gdi32.lib
includelib comctl32.lib
includelib comdlg32.lib

include masm32.inc
includelib masm32.lib
include debug.inc
includelib debug.lib

;--------------------------------------------------------------------------------

WinMain				PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD

;--------------------------------------------------------------------------------

FillSolidRect MACRO dc, rect, bkcolor
    invoke SetBkColor, dc, bkcolor
    invoke ExtTextOut, dc, 0, 0, ETO_OPAQUE, rect, NULL, 0, NULL
ENDM

RGB macro red, green, blue
        xor eax, eax
        mov ah, blue
        shl eax, 8
        mov ah, green
        mov al, red
ENDM

m2m MACRO M1, M2
	push M2
	pop  M1
ENDM

;--------------------------------------------------------------------------------

.const

IDM_FILE_EXIT		equ 10001
IDM_HELP_ABOUT		equ 10101

;--------------------------------------------------------------------------------

.data

ClassName			db 'DLGCLASS',0
MenuName			db 'MyMenu',0
DlgName				db 'MyDialog',0
AppName				db 'ListBoxOwnerDemo',0
AboutMsg			db 'Code By X05. X05_44960@hotmail.com',13,10,13,10,'ListBoxOwnerDemo (rev 1)',0
szDWORDfmt          db '%8.8X', 0

;--------------------------------------------------------------------------------

.data?

hInstance			dd ?
CommandLine			dd ?
hWnd				dd ?

mis                 MEASUREITEMSTRUCT <?>
dis                 DRAWITEMSTRUCT    <?> ; For WM_DRAWITEM

;--------------------------------------------------------------------------------

.code

DRAWITEM proc uses edi esi ecx, param:DWORD
        
    LOCAL szBuf[255]:BYTE
    LOCAL crSelected:COLORREF
    LOCAL crSelectedText:COLORREF
    LOCAL crNormal:COLORREF
    LOCAL crText:COLORREF
    LOCAL iItem:DWORD
    LOCAL rItemRect:RECT
    LOCAL rTextRect:RECT
    LOCAL rValueRect:RECT
    LOCAL i:DWORD
    LOCAL nBkMode:DWORD
        
    mov esi, param
    lea edi, dis
    mov ecx, sizeof dis
    rep movsb    
    
    .if ( dis.itemID == -1 )
    	ret
    .endif
    
    .if ( !dis.hdc )
    	ret
    .endif
                    
    invoke CopyRect, ADDR rItemRect, ADDR dis.rcItem
    invoke CopyRect, ADDR rTextRect, ADDR dis.rcItem
    invoke CopyRect, ADDR rValueRect, ADDR dis.rcItem
    
    ; 
    sub rTextRect.right, 60
    mov eax, rTextRect.right
    inc eax
    add rValueRect.left, eax
    
    mov eax, dis.itemID
    mov iItem, eax
    
    invoke GetSysColor, COLOR_WINDOW
    mov crNormal, eax

    invoke GetSysColor, COLOR_HIGHLIGHT
    mov crSelected, eax
    
    invoke GetSysColor, COLOR_HIGHLIGHTTEXT
    mov crSelectedText, eax

    invoke GetSysColor, COLOR_WINDOWTEXT
    mov crText, eax
        
   	invoke SetBkMode, dis.hdc, TRANSPARENT
   	mov nBkMode, eax
    
    .if ( dis.itemState & ODS_SELECTED )    ; If Selected                                            
        FillSolidRect dis.hdc, ADDR rItemRect, crSelected ; Erase Item   
    .else
        invoke SetTextColor, dis.hdc, crText              
        FillSolidRect dis.hdc, ADDR rItemRect, crNormal   
    .endif
        
    invoke RtlZeroMemory, ADDR szBuf, sizeof szBuf
    invoke SendMessage, dis.hwndItem, LB_GETTEXT, dis.itemID, ADDR szBuf		       		       		       	
    
    invoke SendMessage, dis.hwndItem, LB_GETITEMDATA, dis.itemID, 0
    mov i, eax
    
    .if ( dis.itemState & ODS_SELECTED ) 
        invoke SetTextColor, dis.hdc, crSelectedText
    .else
        .if ( !i )
            RGB 255, 0, 0 ; RED
            invoke SetTextColor, dis.hdc, eax
        .else
            invoke SetTextColor, dis.hdc, crText
        .endif
    .endif  
        
    invoke StrLen, ADDR szBuf
    invoke TextOut, dis.hdc, rTextRect.left, rTextRect.top, ADDR szBuf, eax

    invoke wsprintf, ADDR szBuf, ADDR szDWORDfmt, i
    invoke StrLen, ADDR szBuf
    invoke TextOut, dis.hdc, rValueRect.left, rValueRect.top, ADDR szBuf, eax

    .if ( dis.itemState & ODS_FOCUS )
        invoke DrawFocusRect, dis.hdc, ADDR dis.rcItem
    .endif

    mov eax, 1
    ret
DRAWITEM endp