
; Macro for easier error messages, actually a CTEXT variation
Err MACRO y:VARARG
	LOCAL sym

CONST segment
	IFIDNI <y>,<>
		sym db 0
	ELSE
		sym db y,0
	ENDIF
CONST ends
	invoke MessageBox,hWnd,offset sym,offset szAppName,MB_OK
	mov 	eax,TRUE
endm

.const

szConnect			db 'DRIVER={Microsoft Access Driver (*.mdb)};DBQ=',0
szDBName			db 'ODBCTest.mdb',0
szSqlSelectAll		db 'SELECT * FROM Customer',0
szSqlSelectID		db 'SELECT * FROM Customer WHERE ID=?',0

.data?

hEnv				dd ?
hConn				dd ?
nRows				dd ?

.code

;Connect to database
ODBCConnect proc uses esi edi,lpFilename:DWORD
	LOCAL	lnCon:DWORD

	invoke SQLAllocHandle,SQL_HANDLE_ENV,SQL_NULL_HANDLE,offset hEnv
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetEnvAttr,hEnv,SQL_ATTR_ODBC_VERSION,SQL_OV_ODBC3,0
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke SQLAllocHandle,SQL_HANDLE_DBC,hEnv,offset hConn
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,1024
				mov		esi,eax
				invoke lstrcpy,esi,offset szConnect
				invoke lstrcat,esi,lpFilename
				invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,1024
				mov		edi,eax
				invoke lstrlen,esi
				mov		edx,eax
				invoke SQLDriverConnect,hConn,0,esi,edx,edi,1024,addr lnCon,SQL_DRIVER_COMPLETE
				.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
					xor eax,eax
				.else
					invoke SQLFreeHandle,SQL_HANDLE_DBC,hConn
					invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
					mov		hConn,0
					mov		hEnv,0
					Err 'Unable to connect to the database.'
				.endif
				push	eax
				invoke GlobalFree,esi
				invoke GlobalFree,edi
				pop		eax
			.else
				invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
				mov		hEnv,0
				Err 'Unable to allocate ODBC connection handle.'
			.endif
		.else
			invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
			mov		hEnv,0
			Err 'Unable to set ODBC environment attributes.'
		.endif
	.else
		Err 'Unable to allocate ODBC environment handle.'
	.endif
	ret

ODBCConnect endp

;Disconnect from database
ODBCDisconnect proc

	.if hConn
		invoke SQLDisconnect,hConn
		invoke SQLFreeHandle,SQL_HANDLE_DBC,hConn
		invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
		mov		hConn,0
		mov		hEnv,0
	.endif
	ret

ODBCDisconnect endp

;Get a statement handle and set some attributes
ODBCGetStatementHandle proc
	LOCAL	hStmt:DWORD

	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConn,addr hStmt
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetStmtAttr,hStmt,SQL_ATTR_CONCURRENCY,SQL_CONCUR_ROWVER,0
		invoke SQLSetStmtAttr,hStmt,SQL_ATTR_CURSOR_TYPE,SQL_CURSOR_KEYSET_DRIVEN,0
		mov		eax,hStmt
	.else
		Err 'Unable to allocate statement handle.'
		xor		eax,eax
	.endif
	ret

ODBCGetStatementHandle endp

;Bind all or some columns
ODBCBindCols proc uses ebx,hStmt:DWORD,lpData:DWORD,fAllCols:DWORD

	mov		ebx,lpData
	.if fAllCols
		invoke SQLBindCol,hStmt,1,SQL_INTEGER,addr [ebx].CUSTOMER.nID,4,addr [ebx].CUSTOMER.lenID
	.endif
	invoke SQLBindCol,hStmt,2,SQL_CHAR,addr [ebx].CUSTOMER.szName,32,addr [ebx].CUSTOMER.lenName
	invoke SQLBindCol,hStmt,3,SQL_CHAR,addr [ebx].CUSTOMER.szSurname,32,addr [ebx].CUSTOMER.lenSurname
	invoke SQLBindCol,hStmt,4,SQL_CHAR,addr [ebx].CUSTOMER.szTelephoneNo,32,addr [ebx].CUSTOMER.lenTelephoneNo
	ret

ODBCBindCols endp

;Get all rows from table Customer
ODBCGetData proc uses ebx,lpData:DWORD
	LOCAL	hStmt:DWORD
	LOCAL	rowdta[4]:DWORD

	mov		ebx,lpData
	invoke ODBCGetStatementHandle
	.if eax
		mov		hStmt,eax
		invoke SQLExecDirect,hStmt,addr szSqlSelectAll,sizeof szSqlSelectAll
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			mov		nRows,0
			invoke ODBCBindCols,hStmt,ebx,TRUE
		  @@:
			mov		[ebx].CUSTOMER.nID,0
			mov		[ebx].CUSTOMER.szName,0
			mov		[ebx].CUSTOMER.szSurname,0
			mov		[ebx].CUSTOMER.szTelephoneNo,0
			invoke SQLFetch,hStmt
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				mov		eax,[ebx].CUSTOMER.nID
				mov		rowdta,eax
				lea		eax,[ebx].CUSTOMER.szName
				mov		rowdta+4,eax
				lea		eax,[ebx].CUSTOMER.szSurname
				mov		rowdta+8,eax
				lea		eax,[ebx].CUSTOMER.szTelephoneNo
				mov		rowdta+12,eax
				invoke SendMessage,hGrd,GM_ADDROW,0,addr rowdta
				inc		nRows
				cmp		nRows,32700
				jne		@b
			.endif
		.else
			Err "Failed to execute query."
		.endif
		invoke SQLFreeHandle,SQL_HANDLE_STMT,hStmt
	.endif
	ret

ODBCGetData endp

;Get single row from table Customer
ODBCGetRowData proc uses ebx,lpData:DWORD
	LOCAL	hStmt:DWORD
	LOCAL	lret:DWORD

	mov		lret,-1
	mov		ebx,lpData
	invoke ODBCGetStatementHandle
	.if eax
		mov		hStmt,eax
		invoke SQLBindParameter,hStmt,1,SQL_PARAM_INPUT,SQL_C_ULONG,SQL_INTEGER,10,0,addr [ebx].CUSTOMER.nID,4,addr [ebx].CUSTOMER.lenID
		invoke SQLExecDirect,hStmt,addr szSqlSelectID,sizeof szSqlSelectID
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke ODBCBindCols,hStmt,ebx,TRUE
			mov		[ebx].CUSTOMER.nID,0
			mov		[ebx].CUSTOMER.szName,0
			mov		[ebx].CUSTOMER.szSurname,0
			mov		[ebx].CUSTOMER.szTelephoneNo,0
			invoke SQLFetch,hStmt
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				mov		lret,0
			.endif
		.else
			Err "Failed to execute query."
		.endif
		invoke SQLFreeHandle,SQL_HANDLE_STMT,hStmt
	.endif
	mov		eax,lret
	ret

ODBCGetRowData endp

;Update single row in Customer
ODBCUpdateData proc uses ebx,lpData:DWORD
	LOCAL	hStmt:DWORD
	LOCAL	lret:DWORD

	mov		lret,-1
	mov		ebx,lpData
	invoke ODBCGetStatementHandle
	.if eax
		mov		hStmt,eax
		invoke SQLBindParameter,hStmt,1,SQL_PARAM_INPUT,SQL_C_ULONG,SQL_INTEGER,10,0,addr [ebx].CUSTOMER.nID,4,addr [ebx].CUSTOMER.lenID
		invoke SQLExecDirect,hStmt,addr szSqlSelectID,sizeof szSqlSelectID
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke SQLFetch,hStmt
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				invoke SQLBindCol,hStmt,2,SQL_CHAR,addr [ebx].CUSTOMER.szName,32,addr [ebx].CUSTOMER.lenName
				invoke SQLBindCol,hStmt,3,SQL_CHAR,addr [ebx].CUSTOMER.szSurname,32,addr [ebx].CUSTOMER.lenSurname
				invoke SQLBindCol,hStmt,4,SQL_CHAR,addr [ebx].CUSTOMER.szTelephoneNo,32,addr [ebx].CUSTOMER.lenTelephoneNo
				invoke SQLSetPos,hStmt,1,SQL_UPDATE,SQL_LOCK_NO_CHANGE
				.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
					mov		lret,0
				.else
					Err "Failed to update."
				.endif
			.else
				Err "Failed to fetch data."
			.endif
		.else
			Err "Failed to execute query."
		.endif
		invoke SQLFreeHandle,SQL_HANDLE_STMT,hStmt
	.endif
	mov		eax,lret
	ret

ODBCUpdateData endp

;Add single row to Customer
ODBCAddData proc uses ebx,lpData:DWORD
	LOCAL	hStmt:DWORD
	LOCAL	lret:DWORD

	mov		lret,-1
	mov		ebx,lpData
	invoke ODBCGetStatementHandle
	.if eax
		mov		hStmt,eax
		invoke SQLExecDirect,hStmt,addr szSqlSelectAll,sizeof szSqlSelectAll
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke SQLFetch,hStmt
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				invoke ODBCBindCols,hStmt,ebx,FALSE
				invoke SQLSetPos,hStmt,0,SQL_ADD,SQL_LOCK_NO_CHANGE
				.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
					invoke ODBCBindCols,hStmt,ebx,TRUE
					invoke SQLFetchScroll,hStmt,SQL_FETCH_LAST,0
					.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
						mov		lret,0
					.else
						Err "Failed to fetch data."
					.endif
				.else
					Err "Failed to add row."
				.endif
			.else
				Err "Failed to fetch data."
			.endif
		.else
			Err "Failed to execute query."
		.endif
		invoke SQLFreeHandle,SQL_HANDLE_STMT,hStmt
	.endif
	mov		eax,lret
	ret

ODBCAddData endp

;Delete single row from Customer
ODBCDelete proc uses ebx,lpData:DWORD
	LOCAL	hStmt:DWORD
	LOCAL	lret:DWORD

	mov		lret,-1
	mov		ebx,lpData
	invoke ODBCGetStatementHandle
	.if eax
		mov		hStmt,eax
		invoke SQLBindParameter,hStmt,1,SQL_PARAM_INPUT,SQL_C_ULONG,SQL_INTEGER,10,0,addr [ebx].CUSTOMER.nID,4,addr [ebx].CUSTOMER.lenID
		invoke SQLExecDirect,hStmt,addr szSqlSelectID,sizeof szSqlSelectID
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke SQLFetch,hStmt
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				invoke SQLSetPos,hStmt,1,SQL_DELETE,SQL_LOCK_NO_CHANGE
				.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
					mov		lret,0
				.else
					Err "Failed to delete data."
				.endif
			.else
				Err "Failed to fetch data."
			.endif
		.else
			Err "Failed to execute query."
		.endif
		invoke SQLFreeHandle,SQL_HANDLE_STMT,hStmt
	.endif
	mov		eax,lret
	ret

ODBCDelete endp

