; Code by X05
; email: X05_44960@hotmail.com
; rev: 1

.386
.model flat,stdcall
option casemap:none

include StatusBarDemo.inc

;--------------------------------------------------------------------------------

.code

start:

	invoke GetModuleHandle, NULL
	mov    hInstance, eax
	invoke GetCommandLine
	invoke InitCommonControls
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess, eax

;--------------------------------------------------------------------------------

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize, SIZEOF WNDCLASSEX
	mov		wc.style, CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc, OFFSET WndProc
	mov		wc.cbClsExtra, NULL
	mov		wc.cbWndExtra, DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground, COLOR_BTNFACE + 1
	mov		wc.lpszMenuName, OFFSET MenuName
	mov		wc.lpszClassName, OFFSET ClassName
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov		wc.hIcon, eax
	mov		wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov		wc.hCursor, eax
	invoke RegisterClassEx, ADDR wc
	invoke CreateDialogParam, hInstance, ADDR DlgName, NULL, ADDR WndProc, NULL
	invoke ShowWindow, hWnd, SW_SHOWNORMAL
	invoke UpdateWindow,  hWnd
	.while TRUE
		invoke GetMessage, ADDR msg, NULL, 0, 0
	  .BREAK .if !eax
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	
	.if ( hBitmap )
    	invoke DeleteObject, hBitmap
    .endif
    
    .if ( hIcon )
        invoke DeleteObject, hIcon
    .endif
    	
	mov		eax,msg.wParam
	ret

WinMain endp

;--------------------------------------------------------------------------------

WndProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov	eax, uMsg
	.if ( eax == WM_DRAWITEM )
        invoke DRAWITEM, lParam
	
;	.elseif ( eax == WM_MEASUREITEM )

	.elseif ( eax == WM_SIZE )
        invoke MoveWindow, hStatus, 0, 0, 0, 0, TRUE
		
	.elseif ( eax == WM_INITDIALOG )
		push hWin
		pop	hWnd
		
		; get handle to icon
        invoke LoadIcon, hInstance, 500
        mov hIcon, eax

        ; set icon to dialog
        invoke SendMessage, hWin, WM_SETICON, ICON_SMALL, hIcon
		
		; get handle to statur bar
		invoke GetDlgItem, hWin, IDC_SBR1
		mov hStatus, eax
		
		; get handle to bitmap
		invoke LoadImage, hInstance, 501, IMAGE_BITMAP, 16, 16, LR_LOADMAP3DCOLORS or LR_LOADTRANSPARENT
        mov hBitmap, eax

        ; setup 4 panels        		
        invoke SendMessage, hStatus, SB_SETPARTS, 4, ADDR dwParts

        ; set style / text
        invoke SetStatusText, 0, SBT_NOBORDERS or SBT_OWNERDRAW, ADDR szText1
        invoke SetStatusText, 1, SBT_OWNERDRAW, ADDR szText2
        invoke SetStatusText, 2, SBT_POPOUT or SBT_OWNERDRAW, ADDR szText3        
        invoke SetStatusText, 3, 0, ADDR szTextNoOwner      

        invoke SendDlgItemMessage, hWin, IDC_EDT_NORMAL, WM_SETTEXT, 0, ADDR szTextNoOwner
        invoke SendDlgItemMessage, hWin, IDC_EDT_OWNER, WM_SETTEXT, 0, ADDR szText4
        
        invoke SetWindowLong, hStatus, GWL_WNDPROC, StatusProc
        mov lpStatusProc, eax
        		
	.elseif ( eax == WM_COMMAND )
		mov	eax, wParam
		and	eax, 0FFFFh
		.if ( eax == IDM_FILE_EXIT )
			invoke SendMessage, hWin, WM_CLOSE, 0, 0
			
		.elseif ( eax == IDM_HELP_ABOUT )
			invoke MessageBox, hWin, ADDR AboutMsg, ADDR AppName, MB_ICONINFORMATION

		.elseif ( eax == IDC_BTN_CLEAR1 )
			 invoke SetStatusText, 0, SBT_NOBORDERS, ADDR szNull
			 
		.elseif ( eax == IDC_BTN_CLEAR2 )
			 invoke SetStatusText, 1, 0, ADDR szNull			 

        .elseif ( eax == IDC_BTN_NORMAL )            
            invoke SendDlgItemMessage, hWin, IDC_EDT_NORMAL, WM_GETTEXT, sizeof szText, ADDR szText
            invoke SetStatusText, 3, 0, ADDR szText
        
        .elseif ( eax == IDC_BTN_OWNER )
            invoke SendDlgItemMessage, hWin, IDC_EDT_OWNER, WM_GETTEXT, sizeof szText, ADDR szText
            invoke SetStatusText, 3, SBT_OWNERDRAW, ADDR szText 
			 	
		.endif	
        
	.elseif ( eax == WM_GETMINMAXINFO )
				
        mov ebx, [lParam]  ; ptr to minmaxinfo struct
        mov (MINMAXINFO ptr [ebx]).ptMinTrackSize.x, 300
        mov (MINMAXINFO ptr [ebx]).ptMinTrackSize.y, 200
	    		
	.elseif ( eax == WM_CLOSE )
		invoke DestroyWindow, hWin
		
	.elseif ( eax == WM_DESTROY )
		invoke PostQuitMessage, NULL
		
	.else
		invoke DefWindowProc, hWin, uMsg, wParam, lParam
		ret
	.endif

	xor eax, eax
	ret
WndProc endp

;--------------------------------------------------------------------------------

end start
