; Code by X05
; email: X05_44960@hotmail.com
; rev: 1

; notes: uses owner draw method to draw colour text & icons
;      : left click in part 2 :)

include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include gdi32.inc
include comctl32.inc
include comdlg32.inc

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib gdi32.lib
includelib comctl32.lib
includelib comdlg32.lib

; debug
;include masm32.inc
;include debug.inc
;includelib masm32.lib
;includelib debug.lib

;--------------------------------------------------------------------------------

WinMain				PROTO hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
WndProc				PROTO hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
DRAWITEM            PROTO param:DWORD
GetStatusText       PROTO nPart:DWORD, nStyle:DWORD, lpText:DWORD
GetStatusTextLen    PROTO bPart:DWORD
StatusProc          PROTO hCtl:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

;--------------------------------------------------------------------------------

RGB macro red,green,blue
        xor eax,eax
        mov ah,blue
        shl eax,8
        mov ah,green
        mov al,red
ENDM

HIWORD	MACRO   bigword	; Retrieves the high word from double word argument

	mov	ebx, bigword
	shr	ebx, 16		; Shift 16 for high word to set to high word
				
ENDM

LOWORD	MACRO bigword	; Retrieves the low word from double word argument

	mov	eax, bigword
	and	eax, 0FFFFh	; Set to low word 

ENDM

;--------------------------------------------------------------------------------

.const

IDC_SBR1            equ 1001
IDC_BTN_CLEAR1      equ 1002
IDC_BTN_CLEAR2      equ 1003
IDC_EDT_NORMAL      equ 1006
IDC_EDT_OWNER       equ 1007
IDC_BTN_NORMAL      equ 1008
IDC_BTN_OWNER       equ 1009
IDM_FILE_EXIT		equ 10001
IDM_HELP_ABOUT		equ 10101

;--------------------------------------------------------------------------------

.data

ClassName			db 'DLGCLASS',0
MenuName			db 'MyMenu',0
DlgName				db 'MyDialog',0
AppName				db 'StatusBarOwnerDrawDemo',0
AboutMsg			db 'Code by X05. Email: X05_44960@hotmail.com',13,10,'StatusBarOwnerDrawDemo (rev1)',0

szText1             db 'Part 1', 0
szText2             db 'Part 2', 0
szText3             db 'Part 3', 0
szText4             db 'Part 4', 0
szTextNoOwner       db 'No Owner Draw', 0
szNull              db 0

dwParts             dd 75
                    dd 150
                    dd 225
                    dd -1

;--------------------------------------------------------------------------------

.data?

hInstance			dd ?
CommandLine			dd ?
hWnd				dd ?
hStatus             dd ?
mis                 MEASUREITEMSTRUCT <?>
dis                 DRAWITEMSTRUCT    <?> ; For WM_DRAWITEM
hIcon               dd ? ; handle to app icon
hBitmap             dd ? ; handle to status bar bitmap
lpStatusProc        dd ? ; handle to status bar window procedure
szText              db 256 dup (?)

;--------------------------------------------------------------------------------

.code

DRAWITEM proc uses esi edi ecx, param:DWORD

    LOCAL hOld:DWORD
    LOCAL memDC:DWORD
  	LOCAL ps:PAINTSTRUCT
  	LOCAL x:DWORD
  	LOCAL y:DWORD  	

    mov esi, param
    lea edi, dis
    mov ecx, sizeof dis
    rep movsb    
                      
    .if ( dis.itemID == -1 )
    	ret
    .endif
    
    .if ( !dis.hdc )
    	ret
    .endif
        
    invoke CreateCompatibleDC, dis.hdc
    mov memDC, eax

    .if ( dis.itemID == 1 )
        RGB 255, 0, 0 ; RED
        
    .elseif ( dis.itemID == 2 )
        RGB 0, 0, 255 ; BLUE
        
    .else
        RGB 0, 0, 0   ; BLACK
        
    .endif

    ; set font colour    	        
    invoke SetTextColor, dis.hdc, eax

    ; transparent background for text
    invoke SetBkMode, dis.hdc, TRANSPARENT
    
    mov eax, dis.rcItem.left
    add eax, 20
    mov x, eax
    
    mov eax, dis.rcItem.top
    add eax, 3
    mov y, eax
        
    ; get text
    lea eax, dis.itemData
    mov eax, [eax]
    push eax    
    invoke lstrlen, eax
    mov ecx, eax
    pop eax
    invoke TextOut, dis.hdc, x, y, eax, ecx           
    
    invoke SelectObject, memDC, hBitmap
    mov hOld, eax

    ; draw icon        
    invoke BitBlt, dis.hdc, dis.rcItem.left, dis.rcItem.top, 16, 16, memDC, 0, 0, SRCCOPY

    invoke SelectObject, dis.hdc, hOld
    invoke DeleteDC, memDC    
    
    ret
DRAWITEM endp    

;--------------------------------------------------------------------------------

SetStatusText proc nPart:DWORD, nStyle:DWORD, lpText:DWORD
	
    mov eax, nPart
    or eax, nStyle
	invoke SendMessage, hStatus, SB_SETTEXT, eax, lpText
    invoke InvalidateRect, hStatus, 0, TRUE
	 
	ret
SetStatusText endp

;--------------------------------------------------------------------------------

GetStatusTextLen proc bPart:DWORD
    LOCAL dwRtn:DWORD
  
    invoke SendMessage, hStatus, SB_GETTEXTLENGTH, bPart, 0

    ; length in low
    and eax, 0FFFFh
    ret
GetStatusTextLen endp

;--------------------------------------------------------------------------------

StatusProc proc uses ebx, hCtl:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL r:RECT
    LOCAL p:POINT

    mov eax, uMsg   
    .if ( eax == WM_LBUTTONUP )
        LOWORD lParam
        HIWORD lParam
        mov p.x, eax
        mov p.y, ebx        
        
        ; get rectangle of pane 1
        invoke SendMessage, hCtl, SB_GETRECT, 1, ADDR r
        invoke PtInRect, ADDR r, p.x, p.y ; is point in rect of part 2
        .if ( eax )       
            ; add code here (usefull for menus..)
            invoke SetStatusText, 1, 0, ADDR szNull
        .endif   
;--------------------------------------------------------------------------------
        
    .elseif ( eax == WM_RBUTTONUP )                 
    .endif
    
    invoke CallWindowProc, lpStatusProc, hCtl, uMsg, wParam, lParam
    ret
StatusProc endp

;--------------------------------------------------------------------------------

