;To view a NOTE place caret
;on the word NOTE and press F2
;To return to code window press Ctrl+F2

;### SEE - NOTE1: ###
.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include UserControl.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    invoke InitCommonControls

;### SEE - NOTE2: ###
	;Create a windowclass for the user control
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset UdcProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,NULL
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,NULL;COLOR_WINDOW+1;COLOR_BTNFACE+1
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset ClassName
	mov		eax,NULL
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc

	;Show dialogbox
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

;### SEE - NOTE3: ###
DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	hFont:DWORD
	LOCAL	nID:DWORD
	LOCAL	lpPaths:DWORD

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		;Get font. Will be passed to UDC's
		invoke SendMessage,hWin,WM_GETFONT,0,0
		mov		hFont,eax
		mov		nID,IDC_UDC1
		;Point to first path string data
		mov		lpPaths,offset szPaths
		;Setup all UDC's
		.while nID<=IDC_UDC8
			invoke SendDlgItemMessage,hWin,nID,UDCM_INIT,hFont,lpPaths
			;Point to next path string data
			invoke lstrlen,lpPaths
			inc		eax
			add		lpPaths,eax
			invoke lstrlen,lpPaths
			inc		eax
			add		lpPaths,eax
			inc		nID
		.endw
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,0,0
			.elseif eax==IDOK
				mov		nID,IDC_UDC1
				;Point to first path string data
				mov		lpPaths,offset szPaths
				.while nID<=IDC_UDC8
					;Point to iniKey string data
					invoke lstrlen,lpPaths
					inc		eax
					add		lpPaths,eax
					;Save UDC's path to ini
					invoke SendDlgItemMessage,hWin,nID,UDCM_SAVE,0,lpPaths
					;Point to next path string data
					invoke lstrlen,lpPaths
					inc		eax
					add		lpPaths,eax
					inc		nID
				.endw
				invoke SendMessage,hWin,WM_CLOSE,0,0
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

;### SEE - NOTE4: ###
UdcProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	rect:RECT
	LOCAL	buffer[MAX_PATH]:BYTE

	.if uMsg==WM_CREATE
		;Create the controls and size/pos them to ClientRect of UDC
		invoke GetClientRect,hWin,addr rect
		invoke CreateWindowEx,0,addr szStatic,NULL,WS_VISIBLE or WS_CHILD,0,0,55,rect.bottom,hWin,IDC_STC,hInstance,0
		mov		edx,rect.right
		sub		edx,56
		sub		edx,rect.bottom
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr szEdit,NULL,WS_VISIBLE or WS_CHILD,55,0,edx,rect.bottom,hWin,IDC_EDT,hInstance,0
		mov		edx,rect.right
		sub		edx,rect.bottom
		invoke CreateWindowEx,0,addr szButton,addr szBtnText,WS_VISIBLE or WS_CHILD,edx,0,rect.bottom,rect.bottom,hWin,IDC_BTN,hInstance,0
	.elseif uMsg==UDCM_INIT
		;Set font
		invoke SendDlgItemMessage,hWin,IDC_STC,WM_SETFONT,wParam,TRUE
		invoke SendDlgItemMessage,hWin,IDC_EDT,WM_SETFONT,wParam,TRUE
		;Set static caption
		invoke SetDlgItemText,hWin,IDC_STC,lParam
		;Point to iniKey
		invoke lstrlen,lParam
		inc		eax
		add		lParam,eax
		;and get path from inifile
 		invoke GetPrivateProfileString,addr szIniPath,lParam,addr szNULL,addr buffer,MAX_PATH,addr szIniFile
		invoke SetDlgItemText,hWin,IDC_EDT,addr buffer
	.elseif uMsg==UDCM_SAVE
		;Get path from edit control
		invoke GetDlgItemText,hWin,IDC_EDT,addr buffer,MAX_PATH
		;and save it to ini
;		invoke WritePrivateProfileString,addr szIniPath,lParam,addr buffer,addr szIniFile
	.elseif uMsg==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED && eax==IDC_BTN
			;Get path from edit control
			invoke GetDlgItemText,hWin,IDC_EDT,addr buffer,MAX_PATH
			;Show BrowseForFolder
			invoke BrowseForFolder,hWin,addr buffer,addr ClassName,addr ClassName
			;Set new path to edit
			invoke SetDlgItemText,hWin,IDC_EDT,addr buffer
		.endif
	.elseif uMsg==WM_SETFOCUS
		;Set focus to button
		invoke GetDlgItem,hWin,IDC_BTN
		invoke SetFocus,eax
	.endif
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret

UdcProc endp

end start
