.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include WizDemo.inc

.code

;########################################################################

WizShow proc
	LOCAL	PropSheet:PROPSHEETPAGE
	LOCAL	PropHdr:PROPSHEETHEADER

	; Set up the 1st property sheet
	mov		PropSheet.dwSize,sizeof PROPSHEETPAGE
	mov		PropSheet.dwFlags,PSP_DEFAULT
	mov		eax,hInstance
	mov		PropSheet.hInstance,eax
	mov		PropSheet.pszTemplate,IDD_WIZ1
	mov		PropSheet.pszIcon,0
	mov		PropSheet.pfnDlgProc,offset WizDialog1
	mov		PropSheet.pszTitle,NULL
	mov		PropSheet.lParam,0
	mov		PropSheet.pfnCallback,0
	; Create the 1st property sheet
	invoke CreatePropertySheetPage,addr PropSheet
	mov		hPs[0],eax
	; Set up the 2nd property sheet
	mov		PropSheet.dwSize,sizeof PROPSHEETPAGE
	mov		PropSheet.dwFlags,PSP_DEFAULT
	mov		eax,hInstance
	mov		PropSheet.hInstance,eax
	mov		PropSheet.pszTemplate,IDD_WIZ2
	mov		PropSheet.pszIcon,0
	mov		PropSheet.pfnDlgProc,offset WizDialog2
	mov		PropSheet.pszTitle,NULL
	mov		PropSheet.lParam,0
	mov		PropSheet.pfnCallback,0
	; Create the 2nd property sheet
	invoke CreatePropertySheetPage,addr PropSheet
	mov		hPs[4],eax
	; Set up the 3rd property sheet
	mov		PropSheet.dwSize,sizeof PROPSHEETPAGE
	mov		PropSheet.dwFlags,PSP_DEFAULT
	mov		eax,hInstance
	mov		PropSheet.hInstance,eax
	mov		PropSheet.pszTemplate,IDD_WIZ3
	mov		PropSheet.pszIcon,0
	mov		PropSheet.pfnDlgProc,offset WizDialog3
	mov		PropSheet.pszTitle,NULL
	mov		PropSheet.lParam,0
	mov		PropSheet.pfnCallback,0
	; Create the 3rd property sheet
	invoke CreatePropertySheetPage,addr PropSheet
	mov		hPs[8],eax
	; Set up the property sheet header
	mov		PropHdr.dwSize,sizeof PROPSHEETHEADER
	mov		PropHdr.dwFlags,PSH_WIZARD
	mov		PropHdr.hwndParent,NULL
	mov		eax,hInstance
	mov		PropSheet.hInstance,eax
	mov		PropHdr.pszIcon,0
	mov		PropHdr.pszCaption,NULL
	mov		PropHdr.nPages,3
	mov		PropHdr.nStartPage,0
	mov		PropHdr.phpage,offset hPs
	mov		PropHdr.pfnCallback,0
	; Display the property sheet control
	invoke PropertySheet,addr PropHdr
	ret

WizShow endp

WizDialog1 proc hWin:HWND,uMsg:DWORD,wParam:WPARAM,lParam:LPARAM
	; This dialog processes property page 1

	mov		eax,uMsg
	.if	eax==WM_NOTIFY
		mov	edx,lParam
		mov	eax,[edx].NMHDR.code
		.if eax==PSN_SETACTIVE
			; page gaining focus
			mov		eax,[edx].NMHDR.hwndFrom
			mov		hPropSheet,eax
			invoke PostMessage,hPropSheet,PSM_SETWIZBUTTONS,0,PSWIZB_NEXT or PSN_WIZBACK
			invoke SetWindowLong,hWin,DWL_MSGRESULT,0
		.elseif eax==PSN_KILLACTIVE
			; page loosing focus
			invoke SetWindowLong,hWin,DWL_MSGRESULT,0
		.elseif eax==PSN_RESET
			; Add own cancel code here
		.endif
	.elseif eax==WM_COMMAND
		mov 	eax,wParam
		and		eax,0FFFFh
	.elseif eax==WM_INITDIALOG
		mov		eax,hWin
		mov		hPsDlg[0],eax
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

WizDialog1 endp

WizDialog2 proc hWin:HWND,uMsg:DWORD,wParam:WPARAM,lParam:LPARAM
	; This dialog processes property page 2

	mov	eax,uMsg
	.if	eax==WM_NOTIFY
		mov		edx,lParam
		mov		eax,[edx].NMHDR.code
		.if eax==PSN_SETACTIVE
			; page gaining focus
			mov		eax,[edx].NMHDR.hwndFrom
			mov		hPropSheet,eax
			invoke PostMessage,hPropSheet,PSM_SETWIZBUTTONS,0,PSWIZB_NEXT or PSWIZB_BACK
			invoke SetWindowLong,hWin,DWL_MSGRESULT,0
		.elseif eax==PSN_KILLACTIVE
			; page loosing focus
			invoke SetWindowLong,hWin,DWL_MSGRESULT,0
		.elseif eax==PSN_RESET
			; Add own cancel code here
		.endif
	.elseif eax==WM_COMMAND
		mov 	eax,wParam
		and		eax,0FFFFh
	.elseif eax==WM_INITDIALOG
		mov		eax,hWin
		mov		hPsDlg[4],eax
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

WizDialog2	endp

WizDialog3	proc hWin:DWORD,uMsg:DWORD,wParam:WPARAM,lParam:LPARAM
	; This dialog processes property page 3

	mov	eax,uMsg
	.if	eax==WM_NOTIFY
		mov		edx,lParam
		mov		eax,[edx].NMHDR.code
		.if eax==PSN_SETACTIVE
			; page gaining focus
			mov		eax,[edx].NMHDR.hwndFrom
			mov		hPropSheet,eax
			invoke PostMessage,hPropSheet,PSM_SETWIZBUTTONS,0,PSWIZB_FINISH or PSWIZB_BACK
			invoke SetWindowLong,hWin,DWL_MSGRESULT,0
		.elseif eax==PSN_KILLACTIVE
			; page loosing focus
			invoke SetWindowLong,hWin,DWL_MSGRESULT,0
		.elseif eax==PSN_WIZFINISH
			; Add own finish code here
		.elseif eax==PSN_RESET
			; Add own cancel code here
		.endif
	.elseif eax==WM_COMMAND
		mov 	eax,wParam
		and		eax,0FFFFh
	.elseif eax==WM_INITDIALOG
		mov		eax,hWin
		mov		hPsDlg[8],eax
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

WizDialog3	endp

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
	invoke InitCommonControls
	invoke WizShow
	invoke ExitProcess,0

end start
